if not Millisecs then function Millisecs() return os.clock()* 1000 end end
mod_path = "sys/lua/screamers/"

dofile(mod_path.."items.lua")
dofile(mod_path.."screamer_init.lua")

dofile(mod_path.."screamer/annoying_orange.lua")
dofile(mod_path.."screamer/slender.lua")
dofile(mod_path.."screamer/slendytubbie.lua")
dofile(mod_path.."screamer/wolfman.lua")
dofile(mod_path.."screamer/scp173.lua")

Screamer = {}
Screamer.imagepath = ""
Screamer.screamsoundpath = ""
Screamer.killsoundpath = ""
Screamer.screenpath = ""

Screamer.alwaysMove = false
Screamer.alwaysScream = false
Screamer.visibleMode = false
Screamer.frontAppear = false
Screamer.forceScream = false

--Screamer.autoDamageDist = nil
--Screamer.damageDistance = nil
Screamer.viewDamage = {0,0}
Screamer.defaultDamage = {0,0}

--Screamer.followDistance = nil
--Screamer.minFollowDistance = nil
--Screamer.moveDistance = nil

Screamer.name = "Screamer"
Screamer.lastAppear = 0
Screamer.currentAppear = 0
Screamer.viewAngle = 45
Screamer.viewDistance = 350

Screamer.lastAmbientPlay = 0

Screamer.tab = {}

function UpdateScreamers()	
	for k, s in pairs(Screamer.tab) do
		s:Update()
	end
end

-- Init
screamer_meta = {__index = Screamer}
function CreateScreamer()
	local s = {}
	setmetatable(s, screamer_meta)
	table.insert(Screamer.tab, s)
	
	s.screamImgAlpha = {}
	s.screamImg = {}
	s.screamPlayer = {}
	s.screamDamagePlayer = {}
	s.screamLastDamage = {}
	s.screamDamageDealt = {}
	s.screamPlayerSeen = {}
	s.screamLastDamage = {}
	
	return s
end

function Screamer:Init()
	self:InitImage()
	self.lastAppear = Millisecs()
end

function Screamer:InitImage()
	if self.imagepath and string.len(self.imagepath) > 0 then
		self.img = image(self.imagepath, 0, 0, 3)
		self:UpdateImage()
	end
	
	if self.screenpath and string.len(self.screenpath) > 0 then
		for i = 1, 32 do
			self.screamImgAlpha[i] = 0
			self.screamImg[i] = image(self.screenpath, 0, 0, 2, i)
			imagealpha(self.screamImg[i], 0)
			imagepos(self.screamImg[i], 320, 240, 0)
		end
		self:UpdateScreenImage()
	end
end

-- Movement
function Screamer:teleport(x,y,rot)
	self.x = x
	self.y = y
	
	if rot then
		self.rot = rot
	end
	if self.img then
		imagepos(self.img, self.x, self.y, self.rot)
	end
end

-- Functions
function Screamer:UpdateImage()
	if self.img and self.x and self.y then
		imagepos(self.img, self.x, self.y, self.rot or 0)
	end
end

function Screamer:UpdateScreenImage(id)
	if id then
		local a = (self.screamDamageDealt[id] or 0)/player(id,"maxhealth")
		if self.screamImgAlpha[id] ~= a then
			self.screamImgAlpha[id] = a
			imagealpha(self.screamImg[id], a)
		end
	else
		for _, id in pairs(player(0,"table")) do
			self:UpdateScreenImage(id)
		end
	end
end

function Screamer:appearPercent()
	return tonumber(self.sPercent) or 0
end

function Screamer:setAppearPercent(p)
	self.sPercent = tonumber(p)
end

function Screamer:defaultAppearDelay()
	return tonumber(self.sDelay) or 0
end

function Screamer:setAppearDelay(d)
	self.sDelay = tonumber(d)
end

function Screamer:appearDelay()
	return self:defaultAppearDelay() * (1.5 - self:appearPercent())
end

function Screamer:CanAppear()
	return Millisecs() - self.lastAppear >= self:appearDelay() and self:appearPercent() > 0
end

function Screamer:appearDuration()
	return tonumber(self.sDuration) or 0
end

function Screamer:setAppearDuration(s)
	self.sDuration = tonumber(s)
end

function Screamer:CanHide()
	return Millisecs() - self.currentAppear >= self:appearDuration()
end

function Freeline(x,y,x2,y2)
	local Angle = math.atan2(y - y2,x - x2) - math.pi/2
	local Dist = math.sqrt((x-x2)^2 + (y-y2)^2)
	for i = 1, math.floor(Dist/8) do
		local x = x + math.sin(Angle) * (i*8)
		local y = y - math.cos(Angle) * (i*8)
		if tile(math.floor(x/32), math.floor(y/32), "wall") then return false end
	end
	return true
end

function Screamer:Freeline(x,y)
	return Freeline(self.x, self.y, x, y)
end

function Screamer:isVisible(id,viewAngle,maxDistance,disabledFreeline)
	if player(id,"health") > 0 then
		local Angle = AngleBetween(player(id,"x"), player(id,"y"), self.x, self.y)
		local Dist = math.sqrt((player(id,"x") - self.x)^2 + (player(id,"y") - self.y)^2)
		
		if not maxDistance or Dist < maxDistance then

			-- View line
			local Angle2 = math.deg(Angle)
			local Angle3 = player(id,"rot")
			
			if not viewAngle or math.abs(Angle2 - Angle3) <= viewAngle/2 or math.abs(Angle2 - Angle3) >= 360 - viewAngle/2 or (self.autoDamageDist and Dist < self.autoDamageDist) then
			
				-- Free line
				if not disabledFreeline then
					for i = 1, math.floor(Dist/8) do
						local x = player(id,"x") + math.sin(Angle) * (i*8)
						local y = player(id,"y") - math.cos(Angle) * (i*8)
						if tile(math.floor(x/32), math.floor(y/32), "wall") then
							return false
						end
					end
				end
				
				return true
			end
		end
	end
end

function Screamer:Update()
	if self.visibleMode then
		local found_player_visible = false
		local closest_player
		
		for _, id in pairs(player(0,"tableliving")) do
			local dist = math.sqrt((self.x - player(id,"x"))^2 + (self.y - player(id,"y"))^2)
			local is_visible = self:isVisible(id, self.viewAngle, self.viewDistance)
			local dmg = 0
			
			if is_visible then
				if not found_player_visible then
					found_player_visible = true
				end
				
				if not self.screamDamagePlayer[id] then
					self.screamDamagePlayer[id] = true
				end
				if not self.screamPlayerSeen[id] then
					self.screamPlayerSeen[id] = true
				end
				
				if not self.screamPlayer[id] then
					self.screamPlayer[id] = true
					if string.len(self.screamsoundpath) > 0 then
						parse('sv_sound2 '..id..' "'..self.screamsoundpath..'"')
					end
				end
				
				dmg = math.random(self.viewDamage[1],self.viewDamage[2])
			else
				if self.alwaysScream and self.screamPlayer[id] then
					self.screamPlayer[id] = false
				end
				
				if (self.screamDamagePlayer[id] or self.forceScream) and Freeline(player(id,"x"), player(id,"y"), self.x, self.y) then
					dmg = math.random(self.defaultDamage[1], self.defaultDamage[2])
				end
				
				if self.screamPlayerSeen[id] and self.alwaysMove then
					self.screamPlayerSeen[id] = nil
				end
			end
			
			self.screamLastDamage[id] = dmg
			
			if not self.screamDamageDealt[id] then
				self.screamDamageDealt[id] = 0
			end
			
			if (not self.damageDistance or dist < self.damageDistance) and dmg > 0 then
				self.screamDamageDealt[id] = self.screamDamageDealt[id] + dmg
			
				if self.screamDamageDealt[id] >= player(id,"maxhealth") then
					parse('customkill 0 "'..self.name..'" '..id)
					if string.len(self.killsoundpath) > 0 then
						parse('sv_sound2 '..id..' "'..self.killsoundpath..'"')
					end
				end
			end

			if not self.followDistance or dist < self.followDistance then
				if not closest_player or dist < closest_player[2] then
					closest_player = {id, dist}
				end
			end
		end
		
		if closest_player then
			local id = closest_player[1]
			local dist = closest_player[2]
			
			local Angle = AngleBetween(self.x, self.y, player(id,"x"), player(id,"y"))
			local Rot = math.deg(Angle)
			local x = self.x
			local y = self.y

			if (not self.minFollowDistance or dist >= self.minFollowDistance) and self.moveDistance > 0 and not self.screamPlayerSeen[id] and Freeline(player(id,"x"), player(id,"y"), x, y) then
				_x = self.x + math.sin(Angle) * self.moveDistance
				_y = self.y - math.cos(Angle) * self.moveDistance
				
				if tile(math.floor(_x/32), math.floor(_y/32), "walkable") then
					x = _x
					y = _y
				end
			end
			
			if Rot ~= self.rot or x ~= self.x or y ~= self.y then
				self.rot = Rot
				self.x = x
				self.y = y
				
				if self.img then
					tween_move(self.img, 80, self.x, self.y, self.rot)
				end
			end
		end
		
		if not found_player_visible and self:CanHide() then
			for _, id in pairs(player(0,"tableliving")) do
				self.screamPlayer[id] = nil
				self.screamDamagePlayer[id] = nil
				self.screamPlayerSeen[id] = nil
			end
		
			self.visibleMode = false
			self.lastAppear = Millisecs()
			
			imagealpha(self.img, 0)
		end
	elseif self:CanAppear() then
		local t = player(0,"tableliving")
		local target
		if #t > 0 then
			target = t[math.random(1,#t)]
		end
		
		if target then
			local spawnpoints = {}
			
			for x = -8, 8 do
				for y = -8, 8 do
					if math.abs(x) + math.abs(y) > 3 then
						local px, py = x*32 + 16, y*32 + 16
						
						if not self.frontAppear then
							local invisible_node = not playerViewAngle(target, player(target,"x") + px, player(target,"y") + py, self.viewAngle, self.viewDistance)
							if invisible_node then
								local freeline_node = Freeline(player(target,"x"), player(target,"y"), player(target,"x")+px, player(target,"y")+py)
								if freeline_node then
									table.insert(spawnpoints, {x = player(target,"x")+px, y = player(target,"y")+py})
								end
							end
						else
							local visible_node = playerViewAngle(target, player(target,"x") + px, player(target,"y") + py, self.viewAngle, self.viewDistance)
							if visible_node then
								local freeline_node = Freeline(player(target,"x"), player(target,"y"), player(target,"x")+px, player(target,"y")+py)
								if freeline_node then
									table.insert(spawnpoints, {x = player(target,"x")+px, y = player(target,"y")+py})
								end
							end
						end
					end
				end
			end
			
			if #spawnpoints > 0 then
				local random_spawn = spawnpoints[math.random(1,#spawnpoints)]
				local targetAngle = math.deg(math.atan2(random_spawn.y - player(target,"y"),random_spawn.x - player(target,"x")) - math.pi/2)
				
				self:teleport(random_spawn.x, random_spawn.y, targetAngle)
				
				self.currentAppear = Millisecs()
				self.visibleMode = true
					
				imagealpha(self.img, 1)
			end
		end
	end
	
	for _, id in pairs(player(0,"table")) do
		self.screamLastDamage[id] = self.screamLastDamage[id] or 0
		self.screamDamageDealt[id] = self.screamDamageDealt[id] or 0
	
		if (not self.screamDamagePlayer[id] or not Freeline(self.x, self.y, player(id,"x"), player(id,"y")) or self.screamLastDamage[id] == 0) and self.screamDamageDealt[id] > 0 and player(id,"health") > 0 then
			self.screamDamageDealt[id] = self.screamDamageDealt[id] - 2
			if self.screamDamageDealt[id] < 0 then
				self.screamDamageDealt[id] = 0
			end
		elseif player(id,"health") <= 0 and self.screamDamageDealt[id] > 0 then
			self.screamDamageDealt[id] = 0
		end
	end
	
	self:UpdateScreenImage()
	
	if self.ambient and self:appearPercent() > 0 then
		if Millisecs() - self.lastAmbientPlay >= 0 then
			for i = #self.ambient, 1, -1 do
				if self:appearPercent() >= self.ambient[i].percent then
					parse("sv_sound "..self.ambient[i].path)
					self.lastAmbientPlay = Millisecs() + self.ambient[i].duration
					break
				end
			end
		end
	end
end

function playerViewAngle(id,x,y,viewAngle,maxDistance)
	if player(id,"health") > 0 then
		local Angle = math.deg(AngleBetween(player(id,"x"), player(id,"y"), x, y))
		local Dist = math.sqrt((player(id,"x") - x)^2 + (player(id,"y") - y)^2)
		
		if not maxDistance or Dist < maxDistance then
			-- View line
			local Angle2 = player(id,"rot")
			return math.abs(Angle - Angle2) <= viewAngle/2 or math.abs(Angle - Angle2) >= 360 - viewAngle/2
		end
	end
end

function AngleBetween(fx,fy,tx,ty)
	local Angle = math.atan2(fy-ty,fx-tx) - math.pi/2
	if Angle < -math.pi then return Angle + math.pi*2 end
	return Angle
end

addhook("ms100","update_screamers")
function update_screamers()
	UpdateScreamers()
end

addhook("startround","restart_screamers")
function restart_screamers()
	for _, s in pairs(Screamer.tab) do
		s:InitImage()
	end
end

InitScreamer()

--[[
if string.sub(map("name"), 1, 8) == "slender_" then
	CreateSlender()
elseif string.sub(1, 8) == "wolfman_" then
	CreateWolfman()
elseif string.sub(1, 15) == "slendytubbies_" then
	CreateSlendytubbie()
elseif string.sub(1, 10) == "annoyingo_" then
	CreateAO()
elseif string.sub(1, 7) == "scp173_" then
	CreateSCP173()
end
]]--